<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>PapyrusCDTEditor xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/editor/PapyrusCDTEditor.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher (CEA LIST) Ansgar.Radermacher@cea.fr - Initial API and implementation</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.cdt.texteditor.editor;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.codan.internal.ui.cxx.CodanCReconciler;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ICElement;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ISourceRange;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ISourceReference;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ITranslationUnit;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.internal.ui.editor.CEditor;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.ui.CDTUITools;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IFile;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IMarker;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.CoreException;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.NullProgressMonitor;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.notify.Adapter;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.notify.Notification;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.notify.Notifier;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.URI;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EValidator;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.util.EcoreUtil;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.action.IAction;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.text.ITextSelection;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.text.source.ISourceViewer;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.text.source.IVerticalRuler;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelection;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelectionProvider;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.cdt.texteditor.Activator;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.cdt.texteditor.sync.ObtainICElement;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.cdt.texteditor.sync.RevealCurrentOperation;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.cdt.texteditor.sync.SyncCDTtoModel;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.cdt.texteditor.sync.SyncModelToCDT;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.services.ServiceException;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.services.ServicesRegistry;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.ui.lifecycleevents.DoSaveEvent;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.ui.lifecycleevents.ILifeCycleEventsProvider;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.ui.lifecycleevents.ISaveAndDirtyService;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.ui.lifecycleevents.ISaveEventListener;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.languages.designer.common.texteditor.model.TextEditorModel;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.custom.StyledText;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.FocusEvent;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.FocusListener;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionEvent;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionListener;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Composite;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.IActionBars;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.IEditorInput;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.IEditorPart;
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.IWorkbenchPage;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.IWorkbenchPart;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.PartInitException;
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.PlatformUI;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.ide.IGotoMarker;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.part.FileEditorInput;
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.texteditor.ITextEditorActionConstants;
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment"> * A specialization of the CDT editor made for integration into Papyrus</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/editor/PapyrusCDTEditor.html">PapyrusCDTEditor</a> <strong class="jxr_keyword">extends</strong> CEditor {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  	<em class="jxr_javadoccomment">/** the service registry */</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> ServicesRegistry registry;
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	<em class="jxr_javadoccomment">/** the papyrus text instance */</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../../../../../org/eclipse/papyrus/languages/designer/common/texteditor/model/TextEditorModel.html">TextEditorModel</a> papyrusTextInstance;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  	<em class="jxr_javadoccomment">/** the text listener */</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  	<strong class="jxr_keyword">protected</strong> FocusListener focusListener;
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String EDITOR_DEFAULT_NAME = <span class="jxr_string">"CDT Editor"</span>;
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String EDITOR_TYPE = <span class="jxr_string">"CDTEditorInPapyrus"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/sync/SyncCDTtoModel.html">SyncCDTtoModel</a> syncCpp;
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/sync/RevealCurrentOperation.html">RevealCurrentOperation</a> reveal;
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  	<strong class="jxr_keyword">protected</strong> Adapter gotoListener;
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">	 * Constructor.</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 * @param registry</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_javadoccomment">	 * @param papyrusTextInstance</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/editor/PapyrusCDTEditor.html">PapyrusCDTEditor</a>(<strong class="jxr_keyword">final</strong> ServicesRegistry registry, <strong class="jxr_keyword">final</strong> <a href="../../../../../../../../../org/eclipse/papyrus/languages/designer/common/texteditor/model/TextEditorModel.html">TextEditorModel</a> papyrusTextInstance) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		<strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		gotoListener = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		<strong class="jxr_keyword">this</strong>.registry = registry;
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">this</strong>.papyrusTextInstance = papyrusTextInstance;
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			saveAndDirtyService = registry.getService(ISaveAndDirtyService.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 			saveAndDirtyService.registerIsaveablePart(<strong class="jxr_keyword">this</strong>);
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 			ILifeCycleEventsProvider lifeCycleEvents = registry.getService(ILifeCycleEventsProvider.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			ISaveEventListener preSaveEvent = <strong class="jxr_keyword">new</strong> ISaveEventListener() {
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 				@Override
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 				<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> doSaveAs(DoSaveEvent event) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 					<em class="jxr_comment">// TODO Auto-generated method stub</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 				}
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 				@Override
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 				<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> doSave(DoSaveEvent event) {
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 					syncCpp.syncCDTtoModel();
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 				}
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 			};
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			lifeCycleEvents.addAboutToDoSaveListener(preSaveEvent);
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		} <strong class="jxr_keyword">catch</strong> (ServiceException e) {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 			Activator.log.error(e);
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		}
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 	}
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> <em class="jxr_javadoccomment">	 * override method in order to save &amp; restore action bars entries</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 	@Override
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> createPartControl(Composite parent) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		<em class="jxr_comment">// save Papyrus (GMF) handlers</em>
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		IActionBars actionBars = getEditorSite().getActionBars();
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		<strong class="jxr_keyword">if</strong> ((actionBars != <strong class="jxr_keyword">null</strong>) &amp;&amp; (gmfUndo == <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			gmfUndo = actionBars.getGlobalActionHandler(ITextEditorActionConstants.UNDO);
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 			gmfRedo = actionBars.getGlobalActionHandler(ITextEditorActionConstants.REDO);
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		}
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 		<strong class="jxr_keyword">super</strong>.createPartControl(parent);
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		<strong class="jxr_keyword">if</strong> (actionBars != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 			<em class="jxr_comment">// save CDT (textEditor) handlers</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 			textUndo = actionBars.getGlobalActionHandler(ITextEditorActionConstants.UNDO);
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 			textRedo = actionBars.getGlobalActionHandler(ITextEditorActionConstants.REDO);
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 			<em class="jxr_comment">// &amp; restore Papyrus bar</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 			actionBars.setGlobalActionHandler(ITextEditorActionConstants.UNDO, gmfUndo);
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 			actionBars.setGlobalActionHandler(ITextEditorActionConstants.REDO, gmfRedo);
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 			actionBars.updateActionBars();
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 		}
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		gotoListener = <strong class="jxr_keyword">new</strong> Adapter() {
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 			<em class="jxr_comment">// assure that gotoElement is called, if the element in the model gets updated</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 			@Override
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> notifyChanged(Notification notification) {
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 				<strong class="jxr_keyword">if</strong> (notification.getEventType() == Notification.SET) {
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 					Object newValue = notification.getNewValue();
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 					<strong class="jxr_keyword">if</strong> (newValue instanceof NamedElement) {
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 						gotoElement((NamedElement) newValue);
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 					}
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 				}
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 			}
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 			@Override
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 			<strong class="jxr_keyword">public</strong> Notifier getTarget() {
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 			}
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 			@Override
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setTarget(Notifier newTarget) {
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 			}
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 			@Override
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isAdapterForType(Object type) {
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 				<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			}
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 		};
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 		papyrusTextInstance.eAdapters().add(gotoListener);
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		<strong class="jxr_keyword">if</strong> (papyrusTextInstance.getSelectedObject() instanceof NamedElement) {
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 			gotoElement((NamedElement) papyrusTextInstance.getSelectedObject());
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		}
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 	}
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> <em class="jxr_javadoccomment">	 * @see org.eclipse.ui.texteditor.AbstractDecoratedTextEditor#createSourceViewer(org.eclipse.swt.widgets.Composite, org.eclipse.jface.text.source.IVerticalRuler, int)</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> <em class="jxr_javadoccomment">	 * @param parent</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> <em class="jxr_javadoccomment">	 * @param ruler</em>
<a class="jxr_linenumber" name="L195" href="#L195">195</a> <em class="jxr_javadoccomment">	 * @param styles</em>
<a class="jxr_linenumber" name="L196" href="#L196">196</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L197" href="#L197">197</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 	@Override
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 	<strong class="jxr_keyword">public</strong> ISourceViewer createSourceViewer(Composite parent, IVerticalRuler ruler, <strong class="jxr_keyword">int</strong> styles) {
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 		<strong class="jxr_keyword">final</strong> ISourceViewer viewer = <strong class="jxr_keyword">super</strong>.createSourceViewer(parent, ruler, styles);
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 		<em class="jxr_comment">// ISourceViewer viewer = new DelegatingSourceViewer(origViewer, (Classifier)papyrusTextInstance.getEditedObject());</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 		focusListener = <strong class="jxr_keyword">new</strong> FocusListener() {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 			@Override
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> focusLost(FocusEvent e) {
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 				<em class="jxr_comment">// potential problem for undo/redo!!</em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 				<strong class="jxr_keyword">if</strong> (isDirty()) {
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 					doSave(<strong class="jxr_keyword">new</strong> NullProgressMonitor());
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 					syncCpp.syncCDTtoModel();
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 					Classifier classifier = (Classifier) papyrusTextInstance.getEditedObject();
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 					<em class="jxr_comment">// regenerate code. TODO: raises update dialog</em>
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 					<em class="jxr_comment">// SyncModelToCDT.syncModelToCDT(classifier);</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 				}
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 				<em class="jxr_comment">// restore handlers</em>
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 				IActionBars actionBars = getEditorSite().getActionBars();
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 				<strong class="jxr_keyword">if</strong> (actionBars != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 					<strong class="jxr_keyword">if</strong> ((gmfUndo != <strong class="jxr_keyword">null</strong>) &amp;&amp; (gmfRedo != <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 						actionBars.setGlobalActionHandler(ITextEditorActionConstants.UNDO, gmfUndo);
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 						actionBars.setGlobalActionHandler(ITextEditorActionConstants.REDO, gmfRedo);
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 						actionBars.updateActionBars();
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 					}
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 				}
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 			}
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 			@Override
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> focusGained(FocusEvent e) {
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 				<em class="jxr_comment">// restore handlers</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 				IActionBars actionBars = getEditorSite().getActionBars();
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 				<strong class="jxr_keyword">if</strong> (actionBars != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 					<strong class="jxr_keyword">if</strong> ((textUndo != <strong class="jxr_keyword">null</strong>) &amp;&amp; (textRedo != <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 						actionBars.setGlobalActionHandler(ITextEditorActionConstants.UNDO, textUndo);
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 						actionBars.setGlobalActionHandler(ITextEditorActionConstants.REDO, textRedo);
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 						actionBars.updateActionBars();
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 					}
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 				}
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 			}
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		};
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 		<em class="jxr_comment">// register focus listener</em>
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 		viewer.getTextWidget().addFocusListener(focusListener);
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 		SelectionListener selectionListener = <strong class="jxr_keyword">new</strong> SelectionListener() {
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 			@Override
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 				IEditorPart ep = getEditorSite().getPage().getActiveEditor();
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 				ISelection selection = getSelectionProvider().getSelection();
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 				<strong class="jxr_keyword">if</strong> ((ep instanceof IGotoMarker) &amp;&amp; (selection instanceof ITextSelection)) {
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 					<strong class="jxr_keyword">if</strong> (((ITextSelection) selection).getLength() &gt; 0) {
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 						<em class="jxr_comment">// don't try to navigate during selection of a chunk of text.</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 						<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 					}
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 					IMarker marker;
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 					<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L254" href="#L254">254</a> <em class="jxr_comment">					 * create a temporary validation marker on the</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> <em class="jxr_comment">					 * srcFile file, call the gotoMarker operation of the editor</em>
<a class="jxr_linenumber" name="L256" href="#L256">256</a> <em class="jxr_comment">					 * and remove the marker afterwards.</em>
<a class="jxr_linenumber" name="L257" href="#L257">257</a> <em class="jxr_comment">					 * TODO: operation activates the model-explorer</em>
<a class="jxr_linenumber" name="L258" href="#L258">258</a> <em class="jxr_comment">					 */</em>
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 					<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 						Element element = reveal.obtainSelectedElement((ITextSelection) selection);
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 						String modelURI = EcoreUtil.getURI(element).toString();
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 						marker = srcFile.createMarker(EValidator.MARKER);
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 						marker.setAttribute(IMarker.SEVERITY, IMarker.SEVERITY_INFO); <em class="jxr_comment">// set severity before URI to avoid marker update without associated icon</em>
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 						marker.setAttribute(EValidator.URI_ATTRIBUTE, modelURI);
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 						IWorkbenchPage wbpage = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 						IWorkbenchPart activePart = wbpage.getActivePart();
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 						((IGotoMarker) ep).gotoMarker(marker);
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 						<em class="jxr_comment">// reactivate this editor</em>
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 						wbpage.activate(activePart);
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 						marker.delete();
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 					} <strong class="jxr_keyword">catch</strong> (CoreException e1) {
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 						<em class="jxr_comment">// TODO Auto-generated catch block</em>
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 						e1.printStackTrace();
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 					}
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 				}
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 			}
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 			@Override
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetDefaultSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 			}
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 		};
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 		<em class="jxr_comment">// TODO: don't add selection listener for the moment. It can cause deadlocks (setting a marker attribute while file is locked, reproducible with cut (^X) on selection)</em>
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 		<em class="jxr_comment">// viewer.getTextWidget().addSelectionListener(selectionListener);</em>
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 		<strong class="jxr_keyword">return</strong> viewer;
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 	}
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L290" href="#L290">290</a> <em class="jxr_javadoccomment">	 * Goto a specific element within the text editor. Currently, only methods are supported.</em>
<a class="jxr_linenumber" name="L291" href="#L291">291</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L292" href="#L292">292</a> <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L293" href="#L293">293</a> <em class="jxr_javadoccomment">	 * @throws CoreException</em>
<a class="jxr_linenumber" name="L294" href="#L294">294</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> gotoElement(NamedElement element) {
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 		ICElement ice = CDTUITools.getEditorInputCElement(m_input);
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 		<strong class="jxr_keyword">if</strong> (ice instanceof ITranslationUnit) {
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 			ITranslationUnit itu = (ITranslationUnit) ice;
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 			ICElement icElement = ObtainICElement.getICElement(syncCpp.getCodeGen(), itu, element);
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 			<strong class="jxr_keyword">if</strong> (icElement instanceof ISourceReference) {
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 				<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 					ISourceRange range = ((ISourceReference) icElement).getSourceRange();
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 					ISourceViewer viewer = getSourceViewer();
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 					viewer.revealRange(range.getStartPos(), 1);
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 					viewer.setSelectedRange(range.getStartPos(), range.getLength());
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 					<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 				} <strong class="jxr_keyword">catch</strong> (CoreException e) {
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 					Activator.log.error(e);
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 				}
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 			}
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 		}
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 	}
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 	@Override
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isDirty() {
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 		<strong class="jxr_keyword">boolean</strong> isDirty = <strong class="jxr_keyword">super</strong>.isDirty();
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 		<strong class="jxr_keyword">if</strong> (isDirty != oldDirty) {
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 			oldDirty = isDirty;
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 			<em class="jxr_comment">// hack. Normally, the saveAndDirtyService detects this itself (should find a solution how it can do that)</em>
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 			<em class="jxr_comment">// ((SaveAndDirtyService) saveAndDirtyService).fireIsDirtyChanged();</em>
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 		}
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 		<strong class="jxr_keyword">return</strong> isDirty;
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 	}
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L328" href="#L328">328</a> <em class="jxr_javadoccomment">	 * We override this method because setInput can't be overriden for TextEditor.</em>
<a class="jxr_linenumber" name="L329" href="#L329">329</a> <em class="jxr_javadoccomment">	 * We replace the default Papyrus input with the CPP file</em>
<a class="jxr_linenumber" name="L330" href="#L330">330</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L331" href="#L331">331</a> <em class="jxr_javadoccomment">	 * @see org.eclipse.ui.editors.text.TextEditor#doSetInput(org.eclipse.ui.IEditorInput)</em>
<a class="jxr_linenumber" name="L332" href="#L332">332</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L333" href="#L333">333</a> <em class="jxr_javadoccomment">	 * @param input</em>
<a class="jxr_linenumber" name="L334" href="#L334">334</a> <em class="jxr_javadoccomment">	 * @throws CoreException</em>
<a class="jxr_linenumber" name="L335" href="#L335">335</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 	@Override
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> doSetInput(IEditorInput input) <strong class="jxr_keyword">throws</strong> CoreException {
<a class="jxr_linenumber" name="L338" href="#L338">338</a> 
<a class="jxr_linenumber" name="L339" href="#L339">339</a> 		URI uri = papyrusTextInstance.eResource().getURI();
<a class="jxr_linenumber" name="L340" href="#L340">340</a> 		Classifier classifier = (Classifier) papyrusTextInstance.getEditedObject();
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 		String generatorID = papyrusTextInstance.getGeneratorID();
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 		srcFile = SyncModelToCDT.syncModelToCDT(classifier, generatorID);
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 		<strong class="jxr_keyword">if</strong> (srcFile == <strong class="jxr_keyword">null</strong> || !srcFile.exists()) {
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> PartInitException(<span class="jxr_string">"Code generation before editing failed. Please check error log"</span>);
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 		}
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 		IEditorInput newInput = <strong class="jxr_keyword">new</strong> FileEditorInput(srcFile);
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 		<em class="jxr_comment">// IStorage storage = new TextStorage(string);</em>
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 		<strong class="jxr_keyword">super</strong>.doSetInput(newInput);
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 		syncCpp = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/sync/SyncCDTtoModel.html">SyncCDTtoModel</a>(newInput, classifier, uri.segment(1), generatorID);
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 		m_input = newInput;
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 		reveal = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/sync/RevealCurrentOperation.html">RevealCurrentOperation</a>(newInput, classifier, uri.segment(1));
<a class="jxr_linenumber" name="L354" href="#L354">354</a> 
<a class="jxr_linenumber" name="L355" href="#L355">355</a> 		<em class="jxr_comment">// add the reconciler to get syntax check and completion. (still no full checks)</em>
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 		addReconcileListener(<strong class="jxr_keyword">new</strong> CodanCReconciler());
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 	}
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 
<a class="jxr_linenumber" name="L359" href="#L359">359</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L360" href="#L360">360</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L361" href="#L361">361</a> <em class="jxr_javadoccomment">	 * @see org.eclipse.ui.editors.text.TextEditor#dispose()</em>
<a class="jxr_linenumber" name="L362" href="#L362">362</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L363" href="#L363">363</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 	@Override
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> dispose() {
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 		saveAndDirtyService.removeIsaveablePart(<strong class="jxr_keyword">this</strong>);
<a class="jxr_linenumber" name="L368" href="#L368">368</a> 		<strong class="jxr_keyword">if</strong> (gotoListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L369" href="#L369">369</a> 			papyrusTextInstance.eAdapters().remove(gotoListener);
<a class="jxr_linenumber" name="L370" href="#L370">370</a> 		}
<a class="jxr_linenumber" name="L371" href="#L371">371</a> 
<a class="jxr_linenumber" name="L372" href="#L372">372</a> 		<em class="jxr_comment">// we remove the listener</em>
<a class="jxr_linenumber" name="L373" href="#L373">373</a> 		StyledText st = getSourceViewer().getTextWidget();
<a class="jxr_linenumber" name="L374" href="#L374">374</a> 		st.removeFocusListener(focusListener);
<a class="jxr_linenumber" name="L375" href="#L375">375</a> 		<strong class="jxr_keyword">super</strong>.dispose();
<a class="jxr_linenumber" name="L376" href="#L376">376</a> 		<em class="jxr_comment">// assure that embedded text widget is disposed now. Otherwise, it will be closed</em>
<a class="jxr_linenumber" name="L377" href="#L377">377</a> 		<em class="jxr_comment">// later, when the editorSite is already set to null by Papyrus (mainEditorSite attribute in MultiPageEditorSite4x)</em>
<a class="jxr_linenumber" name="L378" href="#L378">378</a> 		<em class="jxr_comment">// resulting in a null pointer exception and resulting inconsistencies in the Papyrus editor.</em>
<a class="jxr_linenumber" name="L379" href="#L379">379</a> 		st.dispose();
<a class="jxr_linenumber" name="L380" href="#L380">380</a> 	}
<a class="jxr_linenumber" name="L381" href="#L381">381</a> 
<a class="jxr_linenumber" name="L382" href="#L382">382</a> 	<strong class="jxr_keyword">protected</strong> IAction gmfUndo, gmfRedo;
<a class="jxr_linenumber" name="L383" href="#L383">383</a> 
<a class="jxr_linenumber" name="L384" href="#L384">384</a> 	<strong class="jxr_keyword">protected</strong> IAction textUndo, textRedo;
<a class="jxr_linenumber" name="L385" href="#L385">385</a> 
<a class="jxr_linenumber" name="L386" href="#L386">386</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">boolean</strong> oldDirty;
<a class="jxr_linenumber" name="L387" href="#L387">387</a> 
<a class="jxr_linenumber" name="L388" href="#L388">388</a> 	<strong class="jxr_keyword">protected</strong> ISaveAndDirtyService saveAndDirtyService;
<a class="jxr_linenumber" name="L389" href="#L389">389</a> 
<a class="jxr_linenumber" name="L390" href="#L390">390</a> 	<strong class="jxr_keyword">protected</strong> IFile srcFile;
<a class="jxr_linenumber" name="L391" href="#L391">391</a> 
<a class="jxr_linenumber" name="L392" href="#L392">392</a> 	<strong class="jxr_keyword">protected</strong> ISelectionProvider sp;
<a class="jxr_linenumber" name="L393" href="#L393">393</a> 
<a class="jxr_linenumber" name="L394" href="#L394">394</a> 	<strong class="jxr_keyword">protected</strong> IEditorInput m_input;
<a class="jxr_linenumber" name="L395" href="#L395">395</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
